MALLOC(3)

NAME
malloc - general memory allocation function

LIBRARY
libc

SYNOPSIS
#include <stdlib.h>
void *
malloc(size_t size);

DESCRIPTION
The malloc() function allocates uninitialized space for an object whose size is specified by size. The malloc() function maintains multiple lists of free blocks according to size, allocating space from the appropriate list.

The allocated space is suitably aligned (after possible pointer coercion) for storage of any type of object. If the space is of pagesize or larger, the memory returned will be page-aligned.

RETURN VALUES
The malloc() function returns a pointer to the allocated space if successful; otherwise a null pointer is returned.

SEE ALSO
brk(2), alloca(3), calloc(3), free(3), getpagesize(3), memory(3), realloc(3)

STANDARDS
The malloc() function conforms to ansiC.

BUGS
The current implementation of malloc() does not always fail gracefully when system memory limits are approached. It may fail to allocate memory when larger free blocks could be broken up, or when limits are exceeded because the size is rounded up. It is optimized for sizes that are powers of two.